#include "timer.h"

#ifdef _WIN32
#include <windows.h>
#endif

using namespace std;

timer::timer()
{
#ifdef _WIN32
	QueryPerformanceFrequency((LARGE_INTEGER*)&frequency);
	QueryPerformanceCounter((LARGE_INTEGER*)&prevTime);
#else
  gettimeofday(&tp, NULL);
#endif
}

timer::~timer() {

}

long long timer::tick()
{
#ifdef _WIN32
	long long tmpTime = prevTime;
	QueryPerformanceCounter((LARGE_INTEGER*)&prevTime);
	return (prevTime - tmpTime)*(double)1000000./frequency;
#else
  struct timeval tmpTime = tp;
  gettimeofday(&tp, NULL);
  return (1000000LL*(tp.tv_sec-tmpTime.tv_sec)+tp.tv_usec-tmpTime.tv_usec);
#endif
}
